



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>spark中利用Sql2o连接数据的例子BlogService</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">spark中利用Sql2o连接数据的例子BlogService</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 14:36:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>最近在看学习Spark Framework.</p>
<p>这是一个web框架,宗旨正如<a href="http://sparkjava.com/" rel="external nofollow noreferrer">其官网LInk</a>所示:Spark - A micro framework for creating web applications in Kotlin and Java 8 with minimal effort</p>
<p>我按着它的例子来学习.这里碰见了BlogService项目<a href="http://sparkjava.com/tutorials/sql2o-database" rel="external nofollow noreferrer">[传送门]</a>,也算是其主线一步步搭上来的例子了.&nbsp; // 对应的github[<a href="https://github.com/sparktutorials/BlogService_SparkExample" rel="external nofollow noreferrer">传送门</a>]</p>
<p>我本机是Mysql,需要注意:</p>
<p>Mysql并没有UUID数据类型,我用的是char(50)来代替,所以整个项目也要对应的修改引用类型。</p>
<p>至于char(50)类型，是可以直接通过java中的String类型进行对接的。</p>
<p><strong>这里说说自己遇到的几个问题：</strong></p>
<p>问题1: <strong>Could not acquire a connection from DataSource - No suitable driver found for jdbc:mysql://localhost:3306/blog</strong></p>
<p>这是因为没有mysql连接驱动的问题，建议搜索[<a href="https://mvnrepository.com/" rel="external nofollow noreferrer">mysql repository]</a>在里面搜索 [<a href="https://mvnrepository.com/artifact/mysql/mysql-connector-java" rel="external nofollow noreferrer">mysql-connector-java</a>] 选择 MYSQL Connector/J</p>
<p>进去之后选择对应版本。比如我的是5.14，进入之后</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1193530/201708/1193530-20170807172159580-405018635.png" /></p>
<p>把这段加入maven的&lt;dependencies&gt;中， 重新 mvn compile 一遍项目即可</p>
<p>这些maven下载的依赖包，最终一般都会存储在&nbsp; <strong>~/.m2/repository</strong> 中。</p>
<p>小tips： 我在网上查询这个问题的时候，有人居然直接让人把 mysql-connector-java-bin.jar 这个现成的jar包放入&nbsp; .../jre/lib/ext/中</p>
<p>这样当然是可以解决问题的，但是十分不应该。</p>
<p><strong>原因主要有2个：</strong></p>
<ul><li>这样绕开了类路径。当手工地加载其他的类文件时，如果将它们存在扩展路径上，则不能正常的工作。</li>
<li>程序员经常会忘记3个月前所存放文件的位置。当类加载器忽略了曾今仔细设计的类路径时，程序员会毫无头绪地在头文件中查找。事实上，加载的是扩展路径上已经长时间遗忘的类。</li></ul>
<p>问题2：<strong>刚安装完数据库的时候</strong></p>
<div><strong>mysql&gt; show databases;</strong></div>
<div><strong>ERROR 1820 (HY000): You must reset your password using ALTER USER statement before executing this....</strong></div>
<div>这时候只需要设置（用户自己初始化）一下密码即可</div>
<div>
<div>
<pre class="prettyprint linenums">mysql&gt; set password = password('your_password');</pre>
</div>
<p>问题3：当我想要让我的blogservice远程连接数据库的时候，怎么连都失败，我也开放了权限，也设置了防火墙。</p>
<p>于是我在局域网中找了一台有mysql的机子试着连接自己，发现提示<strong>错误号 111</strong></p>
<p>原来，mysql在配置文件还有一层设置，使得只能 localhost连接。</p>
<p>想办法找到配置文件（各个版本可能不同，得自己找找），找到这样一句话</p>
<p><strong>--bind-address="localhost"</strong></p>
<p>注释掉，或者改成&ldquo;*&rdquo; ，或者是欲连接自己的ip即可</p>
<p>问题4: blogservice的post 只接受一个json对象..如果我是数组形式，他是无法接收的</p>
<p>所以我得想办法解决一下这个解析的问题。按理说，它相关依赖的json解析包是有对应方法的，但是我选择了自己熟悉的一种。</p>
<p>首先去[<a href="https://mvnrepository.com/" rel="external nofollow noreferrer">maven repository</a>]搜索&nbsp; [<a href="https://mvnrepository.com/artifact/net.sf.json-lib/json-lib/2.4" rel="external nofollow noreferrer">json-lib</a>]</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1193530/201708/1193530-20170807174915190-547854001.png" /></p>
<p>但是要注意，这样是不可行的，它其实还需要一句支持：完整应该是：</p>
<div>
<pre class="prettyprint linenums">&lt;!-- https://mvnrepository.com/artifact/net.sf.json-lib/json-lib --&gt;<br />
&lt;dependency&gt;<br />
   &lt;groupId&gt;net.sf.json-lib&lt;/groupId&gt;<br />
   &lt;artifactId&gt;json-lib&lt;/artifactId&gt;<br />
   &lt;version&gt;2.4&lt;/version&gt;<br />
   &lt;classifier&gt;jdk15&lt;/classifier&gt;<br />
&lt;/dependency&gt;</pre>
</div>
<p>mvn compile完，在代码中引入包即可</p>
<div>
<pre class="prettyprint linenums">import net.sf.json.JSONArray;<br />
import net.sf.json.JSONObject; </pre>
</div>
<p>之后的关键在于：</p>
<div>
<pre class="prettyprint linenums">ArrayList&lt;V&gt; value = new ArrayList&lt;V&gt;();<br />
if (valueClass != EmptyPayload.class){                           // 如果负载非空<br />
       JSONArray js_a = JSONArray.fromObject(request.body());<br />
       for(int i = 0; i &lt; js_a.size(); ++i){<br />
              System.out.println(((JSONObject)js_a.get(i)).toString());<br />
              V tmp = objectMapper.readValue(((JSONObject)js_a.get(i)).toString(),valueClass);<br />
              value.add(tmp);<br />
       }<br />
 }</pre>
</div>
<p>如果负载非空，比如为post ／ get 类型，那么就把request.body()整一个String读取后化成JSONArray</p>
<p>之后，遍历JSONArray，使其一个个变成Java对象即可。</p>
<p>留意&nbsp;&nbsp;&nbsp; protected abstract Answer processImpl(ArrayList&lt;V&gt; value, Map&lt;String, String&gt; urlParams, boolean shouldReturnHtml);&nbsp; 这些地方的函数声明要一并修改好。</p>
<p>另外就是以后post的时候，即使是一个对象，也需要以数组的形式发送，Json数组：</p>
<div>
<pre class="prettyprint linenums">[<br />　　{<br />　　　　"param1" : "value_String",<br />　　　　"param2" : value_num<br />　　　　...<br />　　},<br />　　{<br />　　　　"param1" : "value_String",<br />　　　　"param2" : value_num<br />　　　　...<br />　　}<br />
]</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv2kgy9.html">《C&num;高级编程》学习总结之LINQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxlp5eq.html">java分享第十一天（接口测试）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4ko5j9.html">OpenStack部署工具总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e2wkm8.html">Redis的复制&lpar;Master&sol;Slave&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw242lq.html">vlc android 移植版编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql43wk9.html">开发常用到的terminal命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/39roldr9.html">spring classpath &amp;amp&semi; classpath&ast;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mdv51q.html">下载Xml文件方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z4ey29.html">&lbrack;Effective C&plus;&plus; --033&rsqb;避免遮掩继承而来的名称</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgz1xq.html">拥抱ARM妹子第二季 之 序：我和春天有个约会 - 生命的萌芽</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1p2o39.html">关于vs2008使用oracleclient链接oracle数据库报报错OCIEnvCreate 失败，返回代码为 -1，但错误消息文本不可用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1zkoz9.html">c&plus;&plus; 12</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wne59.html">linux下Java环境的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy14kgmq.html">关于我的PP0&period;1聊天软件（客户端）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z2ewx9.html">idea 远程调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljdm319.html">走近webpack（3）--图片的处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgx6yd8.html">ccpc杭州站 赛后总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdl05k9.html">干货分享&colon; 长达150页的openvswitch的ppt，不实验无真相</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2kemy9.html">Python3&period;6连接mysql（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwx2kv9.html">【Beta Scrum】冲刺！ 3&sol;5</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qx23m0e8.html">Nginx教程&lpar;五&rpar; Nginx配置文件详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/963rr6y9.html">Ruby&lpar;1&rpar;&colon;入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/963rxpy9.html">&lbrack;转&rsqb; 如何让代码可测试化&lpar;C&num;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvey6xo9.html">&lbrack;PHP&rsqb; 从 PHP 5&period;3&period;X 迁移到 PHP 5&period;6&period;X不兼容点</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp401k9.html">&lbrack;编程&rsqb; C语言的二级指针</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj5gmr8.html">&lbrack;javaSE&rsqb; 集合框架（Map概述）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4poey5q.html">从Linux系统安装到Web应用启动教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql14ljx9.html">01Jenkins环境准备</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4e1v1q.html">【MFC】CHtmlView&colon;&colon;GetSource中文乱码的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v3rj4q.html">Java设计模式&mdash;备忘录模式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
